<template>
  <div>
    <v-card class="card-contenido">
      <v-navigation-drawer
        class="d-inline-block"
        width="600px"
        v-model="drawerLeft"
        :mini-variant.sync="miniLeft"
        permanent
        v-resize="onResize"
        ref="navigationDrawerLeft"
      >
        <v-list-item class="px-2">
          <v-list-item-icon>
            <v-icon @click.stop="miniLeft = !miniLeft">
              <template v-if="!miniLeft"> mdi-eye-off-outline </template>
              <template v-else> mdi-eye-outline </template>
            </v-icon>
          </v-list-item-icon>
          <v-list-item-title class="font-weight-bold">
            <span @click.stop="miniLeft = !miniLeft">Ocultar</span>
          </v-list-item-title>
        </v-list-item>
        <v-divider></v-divider>
        <v-list-item class="px-2">
          <v-list-item-icon>
            <v-icon>mdi-book-information-variant</v-icon>
          </v-list-item-icon>
          <v-list-item-title class="font-weight-bold"
            >Información del documento</v-list-item-title
          >
        </v-list-item>
        <v-list-item v-if="!miniLeft" class="px-2">
          <v-card width="100%" outlined color="#e6e6e6" class="pa-5">
            <p class="font-weight-regular">
              <strong>Documentador:</strong><br />
              {{ folioDocumento.creador.nombre }}
            </p>
            <p class="font-weight-regular">
              <strong>Título:</strong><br />
              {{ folioDocumento.documento.titulo }}
            </p>
            <p class="font-weight-regular">
              <strong>Fecha de creación:</strong><br />
              {{ folioDocumento.fechaCreacion }}
            </p>
            <p class="font-weight-regular">
              <strong>Objetivo:</strong><br />
              {{ folioDocumento.documento.objetivo }}
            </p>
            <p class="font-weight-regular">
              <strong>Versión:</strong><br />
              {{ folioDocumento.documento.version }}
            </p>
            <p class="font-weight-regular">
              <strong>Control de cambios:</strong><br />
              {{ folioDocumento.documento.controlCambios }}
            </p>
            <p class="font-weight-regular">
              <strong>Tags asociados:</strong>
              <br />
              <template v-for="(tag, index) in folio.etiquetas">
                <v-chip
                  class="white--text mr-1"
                  color="#a9a9a9"
                  small
                  label
                  :key="index"
                  >{{ tag.descripcion }}</v-chip
                >
              </template>
            </p>
            <p class="font-weight-regular">
              <strong>Rutas del documento:</strong>
              <br />
              <FolioRutas :folio="folio" />
            </p>
            <div class="mt-2 mb-2">
              <strong>Revisores/Autorizadores</strong>
            </div>
            <template
              v-for="(itemRevisor, indexRevisor) in folio.firmas.todas.filter(
                (itemFirma) => itemFirma.idJerarquia == 1
              )"
            >
              <div :key="'revisor' + indexRevisor">
                <p class="font-weight-regular">
                  <strong>Revisor del documento {{ indexRevisor + 1 }}:</strong>
                  {{ itemRevisor.empleado.nombre }}
                </p>
              </div>
            </template>
            <template
              v-for="(
                itemAutorizador, indexAutorizador
              ) in folio.firmas.todas.filter(
                (itemFirma) => itemFirma.idJerarquia == 2
              )"
            >
              <div :key="'autorizador' + indexAutorizador">
                <p class="font-weight-regular">
                  <strong
                    >Autorizador del documento
                    {{ indexAutorizador + 1 }}:</strong
                  >
                  {{ itemAutorizador.empleado.nombre }}
                </p>
              </div>
            </template>
          </v-card>
        </v-list-item>
        <v-divider></v-divider>
        <v-list-item class="px-2">
          <v-list-item-icon>
            <v-icon>mdi-format-list-text</v-icon>
          </v-list-item-icon>
          <v-list-item-title class="font-weight-bold"
            >Estructura del documento</v-list-item-title
          >
        </v-list-item>
        <v-list-item v-if="!miniLeft" class="px-2">
          <v-list-item-title class="font-weight-bold"
            >Modelo de negocio</v-list-item-title
          >
        </v-list-item>
        <v-list v-show="!miniLeft">
          <v-list-item-group v-model="archivoSelected" color="primary">
            <template v-for="(itemArchivo, index) in folioArchivosModelo">
              <v-divider :key="'divider-modelo-negocio' + index" />
              <v-list-item
                :value="itemArchivo"
                :key="'item-modelo-negocio' + index"
                link
              >
                <v-list-item-icon>
                  <v-icon>mdi-file</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title>{{
                    itemArchivo.nombre
                  }}</v-list-item-title>
                </v-list-item-content>
                <v-list-item-action>
                  <v-icon>mdi-chevron-right</v-icon>
                </v-list-item-action>
              </v-list-item>
            </template>
          </v-list-item-group>
        </v-list>
        <v-list-item v-if="!miniLeft" class="px-2">
          <v-list-item-title class="font-weight-bold"
            >Elementos contextuales</v-list-item-title
          >
        </v-list-item>
        <v-list v-show="!miniLeft">
          <v-list-item-group v-model="archivoSelected" color="primary">
            <template
              v-for="(itemArchivo, index) in folioArchivosModeloContextuales"
            >
              <v-divider :key="'divider-elemento-cotextual' + index" />
              <v-list-item
                :value="itemArchivo"
                :key="'item-elemento-cotextual' + index"
                link
              >
                <v-list-item-icon>
                  <v-icon>mdi-file</v-icon>
                </v-list-item-icon>
                <v-list-item-content>
                  <v-list-item-title>{{
                    itemArchivo.nombre
                  }}</v-list-item-title>
                </v-list-item-content>
                <v-list-item-action>
                  <v-icon>mdi-chevron-right</v-icon>
                </v-list-item-action>
              </v-list-item>
            </template>
          </v-list-item-group>
        </v-list>
      </v-navigation-drawer>
      <div
        class="d-inline-block p-absolute visor-archivos"
        :style="'width:calc(100% - ' + navigationDrawerLeftWidth + 'px);'"
      >
        <FolioVisorArchivo
          v-if="refreshVisorArchivo"
          :folio="localFolio"
          :archivo="archivoSelected"
        />
      </div>
    </v-card>
  </div>
</template>
<style scoped>
.nombre-archivo {
  position: absolute;
  width: 100%;
  top: 0px;
  display: inline-block;
}
.card-contenido {
  position: absolute;
  left: 10px;
  right: 0px;
  height: calc(100% - 96px);
}
.visor-archivos {
  top: 0px;
  overflow-y: auto;
  height: calc(100%);
}
.d-inline-block.v-navigation-drawer {
  overflow-y: auto;
  padding-bottom: 32px;
}
.p-absolute {
  position: absolute;
}
</style>
<script>
import store from "@/store";
import FolioVisorArchivo from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/resumen/componentes/FolioVisorArchivo.vue";
import FolioRutas from "@/views/secure/modelo-negocio/documentos/gestion-documento/pasos/resumen/componentes/FolioRutas.vue";
import moment from "moment";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  name: "Comonenet-FolioDetalle",
  components: {
    FolioVisorArchivo,
    FolioRutas,
  },
  props: ["folio"],
  data() {
    return {
      drawerLeft: false,
      miniLeft: true,
      folioDocumento: {
        documento: {},
        creador: {},
        fechaCreacion: null,
        fimas: {
          todas: [],
        },
      },
      localFolio: null,
      refreshVisorArchivo: false,
      navigationDrawerLeftWidth: 0,
      archivoSelected: null,
      folioArchivosModelo: [],
      folioArchivosModeloContextuales: [],
      etiquetasRelacionadas: [],
      selectedFolioItem: null,
    };
  },
  watch: {
    $route(val) {
      this.init();
    },
    archivoSelected(val, prev) {
      if (!val) {
        this.archivoSelected = prev;
      }
      this.refreshVisorArchivo = false;
      setTimeout(() => {
        this.refreshVisorArchivo = true;
      }, 50);
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    user() {
      let user = serviceLocalStorage.userToken();
      if (!user) {
        user = {};
      }
      return user;
    },
  },
  methods: {
    to(folio) {
      return {
        name: "modelo_negocio_publicados_comentarios_folio",
        params: {
          folio: this.serviceCommons.objectToBase64({
            idFolio: folio.idFolio,
            documento: {
              titulo: folio.documento.titulo,
            },
          }),
        },
      };
    },
    fechaFormat(fechaIn) {
      fechaIn = fechaIn.substr(0, 10);
      let parts_of_date = fechaIn.split("/");
      let output = new Date(
        +parts_of_date[2],
        parts_of_date[1] - 1,
        +parts_of_date[0]
      );
      return moment(output).format("DD/MM/yyyy");
    },
    onResize(event) {
      let navigationDrawerLeftRef = this.$refs.navigationDrawerLeft;
      if (navigationDrawerLeftRef) {
        this.navigationDrawerLeftWidth =
          navigationDrawerLeftRef.$el.clientWidth;
      }
    },
    getFolioDocumento() {
      const self = this;
      axios(
        "/modelo-negocio/folios/v1/busquedas/documentos/" +
          this.localFolio.idFolio
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let fechaCreacion = this.fechaFormat(data.resultado.fechaCreacion);
            data.resultado.fechaCreacion = fechaCreacion;
            self.folioDocumento = data.resultado;
          }
        })
        .catch(function (error) {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getFolioArchivosVirtuales() {
      const self = this;
      axios(
        "/modelo-negocio/folio-virtuales-archivos/v1/" +
          this.localFolio.idFolio +
          "/virtuales/archivos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            data.resultado.folioVirtualesArchivos.forEach((itemArchivo) => {
              if (itemArchivo.tipo == 1) {
                self.folioArchivosModelo.push(itemArchivo);
              } else {
                self.folioArchivosModeloContextuales.push(itemArchivo);
              }
            });
            self.archivoSelected = self.folioArchivosModelo[0];
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getEtiquetasRelacionadas() {
      const self = this;
      axios(
        "/modelo-negocio/catalogos/etiquetas/v1/relacionadas/folios/" +
          this.localFolio.idFolio
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.etiquetasRelacionadas = data.resultado.etiquetas;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            self.etiquetasRelacionadas = [];
          } else {
            console.log(error);
          }
        });
    },
    init() {
      this.localFolio = JSON.parse(JSON.stringify(this.folio));
      this.getEtiquetasRelacionadas();
      this.getFolioArchivosVirtuales();
      this.getFolioDocumento();
    },
  },
  created() {
    this.init();
  },
};
</script>
